<?php
class Desk{
	/**
	 * @var string template path
	 */
	private $tpl;
	
	/**
	 * @var object database
	 */
	private $db;
	
	/**
	 * @var string for database tables
	 */
	private $db_prefix = '';
	
	/**
	 * 
	 * @var string for get param
	 */
	public $page;
	
	private $lang;
	
	public function __construct(){
		global $wpdb;
		$this->db 			= &$wpdb;
		$this->page 		= 'admin.php?page='.$_GET['page'].'&action=';
		$this->db_prefix 	= $this->db->prefix.'datasheet_';
		$this->tpl 			= DS_PLUGIN_PATH_TPL;
		include DS_PLUGIN_PATH.'lang/'.WPLANG.'.php';
		$this->lang = $lang;
	}
	
	public function start(){
		$sql = "SELECT COUNT(`id`) AS `num_rows` FROM `".$this->db_prefix."fields`;";
		$countFields = $this->db->get_results( $sql );
		$sql = "SELECT COUNT(`id`) AS `num_rows` FROM `".$this->db_prefix."groups`;";
		$countGroups = $this->db->get_results( $sql );
		$sql ="SELECT COUNT(DISTINCT `post_id`) AS `num_rows`
			FROM `".$this->db_prefix."field_values`
			INNER JOIN `wp_posts` ON `".$this->db_prefix."field_values`.`post_id` = `wp_posts`.`ID`
			WHERE  `post_status` LIKE  'publish'";
		
		$countPosts = $this->db->get_results( $sql );
		$sql ="SELECT DISTINCT `".$this->db->prefix."posts`.`ID`, `post_title`
			FROM `".$this->db_prefix."field_values`
			INNER JOIN `".$this->db->prefix."posts` ON `".$this->db_prefix."field_values`.`post_id` = `".$this->db->prefix."posts`.`ID`
			WHERE  `post_status` LIKE  'publish'";
		
		$posts = $this->db->get_results( $sql );
		
		$sql = "SELECT * FROM `".$this->db_prefix."output`;";
		
		$template = $this->db->get_results( $sql );
		
		include $this->tpl.'desk.php';
	}
}
?>