<?php
/**
 * handels all around the fields (desk, save, edit)
 * @author sven kronshage
 */
class Field{
	/**
	 * @var string template path
	 */
	private $tpl;
	
	/**
	 * @var object database
	 */
	private $db;
	
	/**
	 * @var string for database tables
	 */
	private $db_prefix = '';
	
	/**
	 * 
	 * @var string for get param
	 */
	public $page;
	
	public function __construct(){
		global $wpdb;
		$this->db 			= &$wpdb;
		$this->page 		= 'admin.php?page='.$_GET['page'].'&action=';
		$this->db_prefix 	= $this->db->prefix.'datasheet_';
		$this->tpl 			= DS_PLUGIN_PATH_TPL;
		include DS_PLUGIN_PATH.'lang/'.WPLANG.'.php';
		$this->lang = $lang;
	}
	/**
	 * a method to switch the field content
	 */
	public function fields(){
		switch( $_GET['action'] ){
			case 'new':
				$types 	= $this->getTypes();
				$groups = $this->getGroups();
				if( $_POST['save'] )
					$save = $this->save();
				if( unserialize( $_POST['field_filled'] ) ){
					$_POST['field_filled'] = unserialize( $_POST['field_filled'] );
				}
				include $this->tpl.'field-process.php';
			break;
			case 'edit':
				$types 	= $this->getTypes();
				$groups = $this->getGroups();
				if( $_POST['save'] )
					$save = $this->save();
				$this->updateField();
				include $this->tpl.'field-process.php';
			break;
			case 'delete':
				$sql = 'DELETE FROM `'.$this->db_prefix.'fields` WHERE `'.$this->db_prefix.'fields`.`id` = '.$_GET['field'];
				$this->db->query( $sql ); 
			default:
				$sql = "SELECT 
					`".$this->db_prefix."fields`.`id`, `".$this->db_prefix."fields`.`label`, 
					`".$this->db_prefix."fields`.`unit`, `".$this->db_prefix."field_types`.`input`,
					`".$this->db_prefix."groups`.`title`
					FROM  `".$this->db_prefix."fields` 
					INNER JOIN `".$this->db_prefix."field_types` ON `".$this->db_prefix."fields`.`type_id` = `".$this->db_prefix."field_types`.`id`
					INNER JOIN `".$this->db_prefix."groups` ON `".$this->db_prefix."fields`.`group_id` = `".$this->db_prefix."groups`.`id`
					ORDER BY `".$this->db_prefix."fields`.`group_id`, `".$this->db_prefix."fields`.`sort`";
				$results = $this->db->get_results( $sql );
				include $this->tpl.'field-desk.php';
			break;
		}
	}
	/**
	 * get all Field types 
	 */
	private function getTypes(){
		$sql = "SELECT * FROM  `".$this->db_prefix."field_types` ";
		return $this->db->get_results( $sql );
	}
	/**
	 * get all Groups
	 */
	private function getGroups(){
		$sql = "SELECT * FROM  `".$this->db_prefix."groups` ";
		return $this->db->get_results( $sql );
	}
	/**
	 * a method to validate field data for update in database
	 */
	private function updateField(){
		$result = $this->db->get_results( "SELECT * FROM  `".$this->db_prefix."fields` WHERE `id`=".$_GET['field'] );
		$_POST['field_name']	= $result[0]->label;
		$_POST['type_id']		= $result[0]->type_id;
		$_POST['field_unit']	= $result[0]->unit;
		$_POST['group_id']		= $result[0]->group_id;
		if( unserialize( $result[0]->filled ) && ( $_POST['type_id'] == 5  || $_POST['type_id'] == 8 || $_POST['type_id'] == 9 ) ){
			$result[0]->filled = unserialize( $result[0]->filled );
			$_POST['field_filled']	= $result[0]->filled;
		}
		
	}
	/**
	 * saves all field data to database
	 */
	private function save(){
		if( is_array( $_POST['filled_values'] ) && $_POST['filled_values'][0] ){
			$size=  sizeof( $_POST['filled_values'] );
			for( $i=0; $i<$size; $i++ ){
				if( $_POST['filled_values'][$i] )
					$values[] = $_POST['filled_values'][$i];
			}
			$_POST['field_filled'] = serialize( $values );
		}
		 
		if( $_GET['action'] == 'new' ){
		$sql = "INSERT INTO  `".$this->db_prefix."fields` (
			`id` ,
			`label` ,
			`type_id` ,
			`unit` ,
			`group_id` ,
			`filled` ,
			`sort`
			)
			VALUES (
				NULL ,  '".$_POST['field_name']."',  
				'".$_POST['type_id']."',  
				'".$_POST['field_unit']."',  
				'".$_POST['group_id']."',  
				'".$_POST['field_filled']."', 
				NULL
			);";
			$result = "Feld erfolgreich angelegt";
		}// if exist
		elseif( $_GET['action'] == 'edit' ){
			$sql = "UPDATE  `".$this->db_prefix."fields` SET  `label` =  '".$_POST['field_name']."', ";
			$sql .= "`type_id` = '".$_POST['type_id']."', "; 
			$sql .= "`unit` = '".$_POST['field_unit']."', ";
			$sql .= "`group_id` = '".$_POST['group_id']."', ";
			$sql .= "`filled` = '".$_POST['field_filled']."' ";
			$sql .= "WHERE  `".$this->db_prefix."fields`.`id` =".$_GET['field'];
			$result = "Feld erfolgreich bearbeitet";
		}
		if( $this->db->query( $sql ) )
			return array( "result" => true, "context" => $result );
	}
}
?>